"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * A public helper function that adds a union description property
 * to a Data Model.
 */
var union = exports.union = function union(UnionDescription) {
    if (!UnionDescription.schemaAttribute) throw new Error("A union requires a schemaAttribute");

    return _extends({}, UnionDescription, {
        _unionDataType: true
    });
};

/**
 * An error type that denotes a response containing
 * GraphQL errors
 */
var GraphQLError = exports.GraphQLError = function (_Error) {
    _inherits(GraphQLError, _Error);

    function GraphQLError(message, errors) {
        _classCallCheck(this, GraphQLError);

        var _this = _possibleConstructorReturn(this, (GraphQLError.__proto__ || Object.getPrototypeOf(GraphQLError)).call(this, message));

        _this.errors = errors;
        return _this;
    }

    return GraphQLError;
}(Error);